ALTER TABLE [dbo].[DimAccount]
    ADD CONSTRAINT [FK_DimAccount_DimAccount] FOREIGN KEY ([ParentAccountKey]) REFERENCES [dbo].[DimAccount] ([AccountKey]) ON DELETE NO ACTION ON UPDATE NO ACTION
GO
ALTER TABLE [dbo].[DimCustomer]
    ADD CONSTRAINT [FK_DimCustomer_DimGeography] FOREIGN KEY ([GeographyKey]) REFERENCES [dbo].[DimGeography] ([GeographyKey]) ON DELETE NO ACTION ON UPDATE NO ACTION
GO
ALTER TABLE [dbo].[DimDepartmentGroup]
    ADD CONSTRAINT [FK_DimDepartmentGroup_DimDepartmentGroup] FOREIGN KEY ([ParentDepartmentGroupKey]) REFERENCES [dbo].[DimDepartmentGroup] ([DepartmentGroupKey]) ON DELETE NO ACTION ON UPDATE NO ACTION
GO
ALTER TABLE [dbo].[DimEmployee]
    ADD CONSTRAINT [FK_DimEmployee_DimEmployee] FOREIGN KEY ([ParentEmployeeKey]) REFERENCES [dbo].[DimEmployee] ([EmployeeKey]) ON DELETE NO ACTION ON UPDATE NO ACTION,
        CONSTRAINT [FK_DimEmployee_DimSalesTerritory] FOREIGN KEY ([SalesTerritoryKey]) REFERENCES [dbo].[DimSalesTerritory] ([SalesTerritoryKey]) ON DELETE NO ACTION ON UPDATE NO ACTION
GO
ALTER TABLE [dbo].[DimGeography]
    ADD CONSTRAINT [FK_DimGeography_DimSalesTerritory] FOREIGN KEY ([SalesTerritoryKey]) REFERENCES [dbo].[DimSalesTerritory] ([SalesTerritoryKey]) ON DELETE NO ACTION ON UPDATE NO ACTION
GO
ALTER TABLE [dbo].[DimOrganization]
    ADD CONSTRAINT [FK_DimOrganization_DimOrganization] FOREIGN KEY ([ParentOrganizationKey]) REFERENCES [dbo].[DimOrganization] ([OrganizationKey]) ON DELETE NO ACTION ON UPDATE NO ACTION,
        CONSTRAINT [FK_DimOrganization_DimCurrency] FOREIGN KEY ([CurrencyKey]) REFERENCES [dbo].[DimCurrency] ([CurrencyKey]) ON DELETE NO ACTION ON UPDATE NO ACTION
GO
ALTER TABLE [dbo].[DimProduct]
    ADD CONSTRAINT [FK_DimProduct_DimProductSubcategory] FOREIGN KEY ([ProductSubcategoryKey]) REFERENCES [dbo].[DimProductSubcategory] ([ProductSubcategoryKey]) ON DELETE NO ACTION ON UPDATE NO ACTION
GO
ALTER TABLE [dbo].[DimProductSubcategory]
    ADD CONSTRAINT [FK_DimProductSubcategory_DimProductCategory] FOREIGN KEY ([ProductCategoryKey]) REFERENCES [dbo].[DimProductCategory] ([ProductCategoryKey]) ON DELETE NO ACTION ON UPDATE NO ACTION
GO
ALTER TABLE [dbo].[DimReseller]
    ADD CONSTRAINT [FK_DimReseller_DimGeography] FOREIGN KEY ([GeographyKey]) REFERENCES [dbo].[DimGeography] ([GeographyKey]) ON DELETE NO ACTION ON UPDATE NO ACTION
GO
ALTER TABLE [dbo].[FactAdditionalInternationalProductDescription]
    ADD CONSTRAINT [FK_FactAdditionalInternationalProductDescription_DimProduct] FOREIGN KEY ([ProductKey]) REFERENCES [dbo].[DimProduct] ([ProductKey]) ON DELETE NO ACTION ON UPDATE NO ACTION
GO
ALTER TABLE [dbo].[FactCallCenter]
    ADD CONSTRAINT [FK_FactCallCenter_DimDate] FOREIGN KEY ([DateKey]) REFERENCES [dbo].[DimDate] ([DateKey]) ON DELETE NO ACTION ON UPDATE NO ACTION
GO
ALTER TABLE [dbo].[FactCurrencyRate]
    ADD CONSTRAINT [FK_FactCurrencyRate_DimDate] FOREIGN KEY ([DateKey]) REFERENCES [dbo].[DimDate] ([DateKey]) ON DELETE NO ACTION ON UPDATE NO ACTION,
        CONSTRAINT [FK_FactCurrencyRate_DimCurrency] FOREIGN KEY ([CurrencyKey]) REFERENCES [dbo].[DimCurrency] ([CurrencyKey]) ON DELETE NO ACTION ON UPDATE NO ACTION
GO
ALTER TABLE [dbo].[FactFinance]
    ADD CONSTRAINT [FK_FactFinance_DimAccount] FOREIGN KEY ([AccountKey]) REFERENCES [dbo].[DimAccount] ([AccountKey]) ON DELETE NO ACTION ON UPDATE NO ACTION,
        CONSTRAINT [FK_FactFinance_DimDepartmentGroup] FOREIGN KEY ([DepartmentGroupKey]) REFERENCES [dbo].[DimDepartmentGroup] ([DepartmentGroupKey]) ON DELETE NO ACTION ON UPDATE NO ACTION,
        CONSTRAINT [FK_FactFinance_DimOrganization] FOREIGN KEY ([OrganizationKey]) REFERENCES [dbo].[DimOrganization] ([OrganizationKey]) ON DELETE NO ACTION ON UPDATE NO ACTION,
        CONSTRAINT [FK_FactFinance_DimScenario] FOREIGN KEY ([ScenarioKey]) REFERENCES [dbo].[DimScenario] ([ScenarioKey]) ON DELETE NO ACTION ON UPDATE NO ACTION,
        CONSTRAINT [FK_FactFinance_DimDate] FOREIGN KEY ([DateKey]) REFERENCES [dbo].[DimDate] ([DateKey]) ON DELETE NO ACTION ON UPDATE NO ACTION
GO
ALTER TABLE [dbo].[FactInternetSalesReason]
    ADD CONSTRAINT [FK_FactInternetSalesReason_DimSalesReason] FOREIGN KEY ([SalesReasonKey]) REFERENCES [dbo].[DimSalesReason] ([SalesReasonKey]) ON DELETE NO ACTION ON UPDATE NO ACTION,
        CONSTRAINT [FK_FactInternetSalesReason_FactInternetSales] FOREIGN KEY ([SalesOrderNumber], [SalesOrderLineNumber]) REFERENCES [dbo].[FactInternetSales] ([SalesOrderNumber], [SalesOrderLineNumber]) ON DELETE NO ACTION ON UPDATE NO ACTION
GO
ALTER TABLE [dbo].[FactInternetSales]
    ADD CONSTRAINT [FK_FactInternetSales_DimCurrency] FOREIGN KEY ([CurrencyKey]) REFERENCES [dbo].[DimCurrency] ([CurrencyKey]) ON DELETE NO ACTION ON UPDATE NO ACTION,
        CONSTRAINT [FK_FactInternetSales_DimCustomer] FOREIGN KEY ([CustomerKey]) REFERENCES [dbo].[DimCustomer] ([CustomerKey]) ON DELETE NO ACTION ON UPDATE NO ACTION,
        CONSTRAINT [FK_FactInternetSales_DimProduct] FOREIGN KEY ([ProductKey]) REFERENCES [dbo].[DimProduct] ([ProductKey]) ON DELETE NO ACTION ON UPDATE NO ACTION,
        CONSTRAINT [FK_FactInternetSales_DimPromotion] FOREIGN KEY ([PromotionKey]) REFERENCES [dbo].[DimPromotion] ([PromotionKey]) ON DELETE NO ACTION ON UPDATE NO ACTION,
        CONSTRAINT [FK_FactInternetSales_DimDate] FOREIGN KEY ([OrderDateKey]) REFERENCES [dbo].[DimDate] ([DateKey]) ON DELETE NO ACTION ON UPDATE NO ACTION,
        CONSTRAINT [FK_FactInternetSales_DimDate1] FOREIGN KEY ([DueDateKey]) REFERENCES [dbo].[DimDate] ([DateKey]) ON DELETE NO ACTION ON UPDATE NO ACTION,
        CONSTRAINT [FK_FactInternetSales_DimDate2] FOREIGN KEY ([ShipDateKey]) REFERENCES [dbo].[DimDate] ([DateKey]) ON DELETE NO ACTION ON UPDATE NO ACTION,
        CONSTRAINT [FK_FactInternetSales_DimSalesTerritory] FOREIGN KEY ([SalesTerritoryKey]) REFERENCES [dbo].[DimSalesTerritory] ([SalesTerritoryKey]) ON DELETE NO ACTION ON UPDATE NO ACTION
GO
ALTER TABLE [dbo].[FactResellerSales]
    ADD CONSTRAINT [FK_FactResellerSales_DimCurrency] FOREIGN KEY ([CurrencyKey]) REFERENCES [dbo].[DimCurrency] ([CurrencyKey]) ON DELETE NO ACTION ON UPDATE NO ACTION,
        CONSTRAINT [FK_FactResellerSales_DimProduct] FOREIGN KEY ([ProductKey]) REFERENCES [dbo].[DimProduct] ([ProductKey]) ON DELETE NO ACTION ON UPDATE NO ACTION,
        CONSTRAINT [FK_FactResellerSales_DimPromotion] FOREIGN KEY ([PromotionKey]) REFERENCES [dbo].[DimPromotion] ([PromotionKey]) ON DELETE NO ACTION ON UPDATE NO ACTION,
        CONSTRAINT [FK_FactResellerSales_DimDate] FOREIGN KEY ([OrderDateKey]) REFERENCES [dbo].[DimDate] ([DateKey]) ON DELETE NO ACTION ON UPDATE NO ACTION,
        CONSTRAINT [FK_FactResellerSales_DimDate1] FOREIGN KEY ([DueDateKey]) REFERENCES [dbo].[DimDate] ([DateKey]) ON DELETE NO ACTION ON UPDATE NO ACTION,
        CONSTRAINT [FK_FactResellerSales_DimDate2] FOREIGN KEY ([ShipDateKey]) REFERENCES [dbo].[DimDate] ([DateKey]) ON DELETE NO ACTION ON UPDATE NO ACTION,
        CONSTRAINT [FK_FactResellerSales_DimEmployee] FOREIGN KEY ([EmployeeKey]) REFERENCES [dbo].[DimEmployee] ([EmployeeKey]) ON DELETE NO ACTION ON UPDATE NO ACTION,
        CONSTRAINT [FK_FactResellerSales_DimReseller] FOREIGN KEY ([ResellerKey]) REFERENCES [dbo].[DimReseller] ([ResellerKey]) ON DELETE NO ACTION ON UPDATE NO ACTION,
        CONSTRAINT [FK_FactResellerSales_DimSalesTerritory] FOREIGN KEY ([SalesTerritoryKey]) REFERENCES [dbo].[DimSalesTerritory] ([SalesTerritoryKey]) ON DELETE NO ACTION ON UPDATE NO ACTION
GO
ALTER TABLE [dbo].[FactSalesQuota]
    ADD CONSTRAINT [FK_FactSalesQuota_DimEmployee] FOREIGN KEY ([EmployeeKey]) REFERENCES [dbo].[DimEmployee] ([EmployeeKey]) ON DELETE NO ACTION ON UPDATE NO ACTION,
        CONSTRAINT [FK_FactSalesQuota_DimDate] FOREIGN KEY ([DateKey]) REFERENCES [dbo].[DimDate] ([DateKey]) ON DELETE NO ACTION ON UPDATE NO ACTION
GO
ALTER TABLE [dbo].[FactSurveyResponse]
    ADD CONSTRAINT [FK_FactSurveyResponse_DateKey] FOREIGN KEY ([DateKey]) REFERENCES [dbo].[DimDate] ([DateKey]) ON DELETE NO ACTION ON UPDATE NO ACTION,
        CONSTRAINT [FK_FactSurveyResponse_CustomerKey] FOREIGN KEY ([CustomerKey]) REFERENCES [dbo].[DimCustomer] ([CustomerKey]) ON DELETE NO ACTION ON UPDATE NO ACTION
GO
PRINT ''
GO
PRINT '*** Creating Functions'
GO
CREATE FUNCTION [dbo].[udfMinimumDate]
(@x DATETIME, @y DATETIME)
RETURNS DATETIME
AS
BEGIN
    DECLARE @z AS DATETIME;
    IF @x <= @y
        SET @z = @x;
    ELSE
        SET @z = @y;
    RETURN (@z);
END
GO
CREATE FUNCTION [dbo].[udfTwoDigitZeroFill]
(@number INT)
RETURNS CHAR (2)
AS
BEGIN
    DECLARE @result AS CHAR (2);
    IF @number > 9
        SET @result = CONVERT (CHAR (2), @number);
    ELSE
        SET @result = CONVERT (CHAR (2), '0' + CONVERT (VARCHAR, @number));
    RETURN @result;
END
GO
CREATE FUNCTION [dbo].[udfBuildISO8601Date]
(@year INT, @month INT, @day INT)
RETURNS DATETIME
AS
BEGIN
    RETURN CAST (CONVERT (VARCHAR, @year) + '-' + [dbo].[udfTwoDigitZeroFill](@month) + '-' + [dbo].[udfTwoDigitZeroFill](@day) + 'T00:00:00' AS DATETIME);
END
GO
PRINT ''
GO
PRINT '*** Creating Table Views'
GO
CREATE VIEW [dbo].[vDMPrep]
AS
SELECT pc.[EnglishProductCategoryName],
       COALESCE (p.[ModelName], p.[EnglishProductName]) AS [Model],
       c.[CustomerKey],
       s.[SalesTerritoryGroup] AS [Region],
       CASE WHEN Month(GetDate()) < Month(c.[BirthDate]) THEN DateDiff(yy, c.[BirthDate], GetDate()) - 1 WHEN Month(GetDate()) = Month(c.[BirthDate])
                                                                                                              AND Day(GetDate()) < Day(c.[BirthDate]) THEN DateDiff(yy, c.[BirthDate], GetDate()) - 1 ELSE DateDiff(yy, c.[BirthDate], GetDate()) END AS [Age],
       CASE WHEN c.[YearlyIncome] < 40000 THEN 'Low' WHEN c.[YearlyIncome] > 60000 THEN 'High' ELSE 'Moderate' END AS [IncomeGroup],
       d.[CalendarYear],
       d.[FiscalYear],
       d.[MonthNumberOfYear] AS [Month],
       f.[SalesOrderNumber] AS [OrderNumber],
       f.SalesOrderLineNumber AS LineNumber,
       f.OrderQuantity AS Quantity,
       f.ExtendedAmount AS Amount
FROM   [dbo].[FactInternetSales] AS f
       INNER JOIN
       [dbo].[DimDate] AS d
       ON f.[OrderDateKey] = d.[DateKey]
       INNER JOIN
       [dbo].[DimProduct] AS p
       ON f.[ProductKey] = p.[ProductKey]
       INNER JOIN
       [dbo].[DimProductSubcategory] AS psc
       ON p.[ProductSubcategoryKey] = psc.[ProductSubcategoryKey]
       INNER JOIN
       [dbo].[DimProductCategory] AS pc
       ON psc.[ProductCategoryKey] = pc.[ProductCategoryKey]
       INNER JOIN
       [dbo].[DimCustomer] AS c
       ON f.[CustomerKey] = c.[CustomerKey]
       INNER JOIN
       [dbo].[DimGeography] AS g
       ON c.[GeographyKey] = g.[GeographyKey]
       INNER JOIN
       [dbo].[DimSalesTerritory] AS s
       ON g.[SalesTerritoryKey] = s.[SalesTerritoryKey]
GO
CREATE VIEW [dbo].[vTimeSeries]
AS
SELECT   CASE [Model] WHEN 'Mountain-100' THEN 'M200' WHEN 'Road-150' THEN 'R250' WHEN 'Road-650' THEN 'R750' WHEN 'Touring-1000' THEN 'T1000' ELSE LEFT([Model], 1) + RIGHT([Model], 3) END + ' ' + [Region] AS [ModelRegion],
         (CONVERT (INT, [CalendarYear]) * 100) + CONVERT (INT, [Month]) AS [TimeIndex],
         Sum([Quantity]) AS [Quantity],
         Sum([Amount]) AS [Amount],
         CalendarYear,
         [Month],
         [dbo].[udfBuildISO8601Date]([CalendarYear], [Month], 25) AS ReportingDate
FROM     [dbo].[vDMPrep]
WHERE    [Model] IN ('Mountain-100', 'Mountain-200', 'Road-150', 'Road-250', 'Road-650', 'Road-750', 'Touring-1000')
GROUP BY CASE [Model] WHEN 'Mountain-100' THEN 'M200' WHEN 'Road-150' THEN 'R250' WHEN 'Road-650' THEN 'R750' WHEN 'Touring-1000' THEN 'T1000' ELSE LEFT(Model, 1) + RIGHT(Model, 3) END + ' ' + [Region], (CONVERT (INT, [CalendarYear]) * 100) + CONVERT (INT, [Month]), CalendarYear, [Month], [dbo].[udfBuildISO8601Date]([CalendarYear], [Month], 25)
GO
CREATE VIEW [dbo].[vTargetMail]
AS
SELECT c.[CustomerKey],
       c.[GeographyKey],
       c.[CustomerAlternateKey],
       c.[Title],
       c.[FirstName],
       c.[MiddleName],
       c.[LastName],
       c.[NameStyle],
       c.[BirthDate],
       c.[MaritalStatus],
       c.[Suffix],
       c.[Gender],
       c.[EmailAddress],
       c.[YearlyIncome],
       c.[TotalChildren],
       c.[NumberChildrenAtHome],
       c.[EnglishEducation],
       c.[SpanishEducation],
       c.[FrenchEducation],
       c.[EnglishOccupation],
       c.[SpanishOccupation],
       c.[FrenchOccupation],
       c.[HouseOwnerFlag],
       c.[NumberCarsOwned],
       c.[AddressLine1],
       c.[AddressLine2],
       c.[Phone],
       c.[DateFirstPurchase],
       c.[CommuteDistance],
       x.[Region],
       x.[Age],
       CASE x.[Bikes] WHEN 0 THEN 0 ELSE 1 END AS [BikeBuyer]
FROM   [dbo].[DimCustomer] AS c
       INNER JOIN
       (SELECT   [CustomerKey],
                 [Region],
                 [Age],
                 Sum(CASE [EnglishProductCategoryName] WHEN 'Bikes' THEN 1 ELSE 0 END) AS [Bikes]
        FROM     [dbo].[vDMPrep]
        GROUP BY [CustomerKey], [Region], [Age]) AS [x]
       ON c.[CustomerKey] = x.[CustomerKey]
GO
CREATE VIEW [dbo].[vAssocSeqOrders]
AS
SELECT DISTINCT [OrderNumber],
                [CustomerKey],
                [Region],
                [IncomeGroup]
FROM   [dbo].[vDMPrep]
WHERE  [FiscalYear] = '2008'
GO
CREATE VIEW [dbo].[vAssocSeqLineItems]
AS
SELECT OrderNumber,
       LineNumber,
       Model
FROM   [dbo].[vDMPrep]
WHERE  FiscalYear = '2008'
GO
PRINT ''
GO
PRINT '*** Disabling DDL Trigger for Database'
GO
PRINT ''
GO
PRINT '*** Changing File Growth Values for Database'
GO
PRINT ''
GO
PRINT '*** Shrinking Database'
GO
